.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\comdlg32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comdlg32.lib

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD


.const
Window_X equ 300
Window_Y equ 175

.data
ClassName    db "NorsrcClass",0
AppName      db "Window No rsrc Example",0


.data?
hInstance HINSTANCE ?

.code
start:

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

LOCAL wc:WNDCLASSEX ; create local variables on stack
LOCAL msg:MSG
LOCAL hwnd:HWND

mov wc.cbSize,SIZEOF WNDCLASSEX ; fill values in members of wc
mov wc.style, CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
mov wc.lpfnWndProc, OFFSET WndProc
mov wc.cbClsExtra,NULL
mov wc.cbWndExtra,NULL
push hInstance
pop wc.hInstance
mov wc.hbrBackground,COLOR_BTNFACE+1 ; COLOR_WINDOW + 9
mov wc.lpszMenuName,NULL
mov wc.lpszClassName,OFFSET ClassName
invoke LoadIcon,NULL,IDI_APPLICATION
mov wc.hIcon,eax
mov wc.hIconSm,eax
invoke LoadCursor,NULL,IDC_ARROW
mov wc.hCursor,eax
invoke RegisterClassEx, addr wc ; register our window class
; retrieve our dimensions (widths and heights) of Windows display elements (All dimensions retrieved are in pixels)
invoke GetSystemMetrics,SM_CXSCREEN
sub eax,Window_X  
shr eax,1
push eax
invoke GetSystemMetrics,SM_CYSCREEN
sub eax,Window_Y  
shr eax,1
pop ebx

; Create the window
invoke CreateWindowEx,NULL,addr ClassName,addr AppName,WS_VISIBLE or WS_POPUP ,ebx,eax,Window_X,Window_Y,NULL,NULL,hInstance,NULL
mov hwnd,eax
invoke ShowWindow, hwnd,SW_SHOWNORMAL ; display our window
invoke UpdateWindow, hwnd

.WHILE TRUE ; The MessageLoop
invoke GetMessage, addr msg,NULL,0,0
.BREAK .IF (!eax)
invoke TranslateMessage, addr msg
invoke DispatchMessage, addr msg
.ENDW


mov eax,msg.wParam
ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

.IF uMsg==WM_CREATE

.ElseIf uMsg == WM_LBUTTONDOWN
invoke SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0
.ELSEIF uMsg==WM_DESTROY || uMsg == WM_RBUTTONUP; Close program

invoke PostQuitMessage,NULL

.ELSE
invoke DefWindowProc,hWnd,uMsg,wParam,lParam
ret
.ENDIF

xor eax,eax
ret

WndProc endp
end start